package {	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	/**
	 * A very simple slider volume control	 
	 * 
	 * @version 1.0
	 * @author Alex Nino
	 */		
	public class Slider extends MovieClip {
		public var level:MovieClip;
		public var slider:MovieClip;
		private var _volume:Number; //show the bar level
		private var _value:Number;
		private var step:uint;
		private var totalSteps:uint;
		private var fromVol:Number;
		function Slider(val:Number = 1, vol:Number = 1.) {
			_value = Math.min(Math.max(0,val), 1); //accepts only value between 0...1
			_volume = Math.min(Math.max(0,vol), 1); //accepts only value between 0...1			
			if (!this.stage) { //was it initialized at this point?
				addEventListener(Event.ADDED_TO_STAGE, init);
			} else {
				init(null);
			}	
		}		
		
		private function init(e:Event):void {
			slider.y = _value * -100;
			level.mouseEnabled = false;
			removeEventListener(Event.ADDED_TO_STAGE, init);
			slider.buttonMode = true;
			slider.addEventListener(MouseEvent.MOUSE_DOWN, drag);
			animateVolume();		
		}
		
		private function drag(e:MouseEvent):void {
			slider.startDrag(false, new Rectangle(0, 0, 0, -100));
			slider.addEventListener(MouseEvent.MOUSE_UP, drop);
			stage.addEventListener(MouseEvent.MOUSE_UP, drop);
			slider.addEventListener(Event.ENTER_FRAME, updateValue);
		}
		
		private function updateValue(e:Event):void {
			_value = slider.y / -100;
			dispatchEvent(new Event(Event.CHANGE));
		}
		
		private function drop(e:MouseEvent):void {
			slider.stopDrag();
			slider.removeEventListener(MouseEvent.MOUSE_UP, drop);
			stage.removeEventListener(MouseEvent.MOUSE_UP, drop);
			slider.removeEventListener(Event.ENTER_FRAME, updateValue);
			updateValue(null);
		}		
		
		public function get volume():Number { return _volume; }		
		public function set volume(value:Number):void {
			_volume = Math.min(Math.max(0,value), 1); //accepts only value between 0...1		
			//animateVolume(); //do not call the animateVolume here, call it from outside
		}
		public function animateVolume():void {
			level.scaleY = _volume;
			fromVol = _volume;
			totalSteps = 5 + Math.round(_volume * 15);
			step = 0;
			if (_volume > 0) {
				level.addEventListener(Event.ENTER_FRAME, refreshVolume);
			}
		}
		
		private function easing(t:Number, b:Number, c:Number, d:Number):Number {
			return c*(t/=d)*t + b; //easeIn
		};
		
		private function refreshVolume(e:Event):void {
			step++;
			_volume = fromVol - easing(step, 0, fromVol, totalSteps);			
			level.scaleY = _volume;
			if (_volume <= 0) {				
				_volume = 0;
				level.removeEventListener(Event.ENTER_FRAME, refreshVolume);
			}
		}
		
		
		public function get value():Number { return _value; }
		
		public function set value(value:Number):void {
			_value = value;
			slider.y = _value * -100;
		}
	}
}