package {	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	/**
	 * A very simple slider volume control	 
	 * 
	 * @version 1.0
	 * @author Alex Nino
	 */		
	public class SliderEx extends MovieClip {		
		public var slider:MovieClip;		
		public var label:TextField;		
		private var _value:Number;		
		private var dragging:Boolean;
		function SliderEx(val:Number = .5) {
			dragging = false;
			_value = Math.min(Math.max(0,val), 1); //accepts only value between 0...1			
			if (!this.stage) { //was it initialized at this point?
				addEventListener(Event.ADDED_TO_STAGE, init);
			} else {
				init(null);
			}	
		}		
		
		private function init(e:Event):void {
			slider.y = _value * -100;			
			removeEventListener(Event.ADDED_TO_STAGE, init);
			slider.buttonMode = true;
			slider.addEventListener(MouseEvent.MOUSE_DOWN, drag);			
		}
		
		private function drag(e:MouseEvent):void {			
			slider.startDrag(false, new Rectangle(0, 0, 0, -100));
			slider.addEventListener(MouseEvent.MOUSE_UP, drop);
			stage.addEventListener(MouseEvent.MOUSE_UP, drop);
			slider.addEventListener(Event.ENTER_FRAME, updateValue);
			dragging = true;
		}
		
		private function updateValue(e:Event):void {
			_value = slider.y / -100;
			dispatchEvent(new Event(Event.CHANGE));
		}
		
		private function drop(e:MouseEvent):void {
			stopDragging();
			updateValue(null);
		}							
		
		private function stopDragging():void {
			if (dragging){
				slider.stopDrag();
				slider.removeEventListener(MouseEvent.MOUSE_UP, drop);
				stage.removeEventListener(MouseEvent.MOUSE_UP, drop);
				slider.removeEventListener(Event.ENTER_FRAME, updateValue);
				dragging = false;
			}
		}
		
		public function get value():Number { return _value; }
		
		public function set value(value:Number):void {
			stopDragging();
			_value = value;
			slider.y = _value * -100;
		}
	}
}